import java.awt.*;

public class Fractal extends Canvas {
	int width, height, maxiteration;
	double x1,x2,y1,y2;
	Fractal( int width, int height, double x1, double y1, double x2, double y2 ) {
		this.width=width;
		this.height=height;
		maxiteration=140;
		newInterval( x1,y1, x2,y2 );
	}
	void newInterval( double x1, double y1, double x2, double y2 ) {
		if(x1<x2) { this.x1=x1;this.x2=x2;}
		else { this.x1=x2;this.x2=x1;}
		if(y1<y2) { this.y1=y1;this.y2=y2;}
		else { this.y1=y2;this.y2=y1;}
	}
	void newInterval( int x1, int y1, int x2, int y2 ) {
		double size=this.x2-this.x1;
		int maxdif=Math.max( x2-x1, y1-y2 ), mdif=6-maxdif;
		if( mdif>=1 ) {
			size*=mdif;
			double xm=getX(x1), ym=getY(y1);
			newInterval( xm-size, ym-size, xm+size, ym+size );
		} else {
			int h=x1; if( x1>x2 ){x1=x2;x2=h;}
			h=y1; if( y1<y2 ){y1=y2;y2=h;}
			double newsize=size*maxdif/width;
			double nx1=getX(x1),ny1=getY(y1);
			//System.out.println( nx1+" : "+ny1+" "+y2+" "+(height-y1)+" "+size+" "+newsize );
			newInterval( nx1, ny1, nx1+newsize, ny1+newsize );
		}
	}
	double getX( int x ) {
		return x1+x*(x2-x1)/width;
	}
	double getY( int y ) {
		return y1+(height-y)*(y2-y1)/height;
	}
	public void paint( Graphics g ) {
		double size=(x2-x1);
		//maxiteration=70+(int)(Math.exp(-Math.log(size)/2));
				//150-(int)(Math.log(size)/Math.log(1.05));
		System.out.println( size+" "+maxiteration );
		for( int y=0; y<getHeight(); y++ ) {
			for( int x=0; x<getWidth(); x++ ) {
				g.setColor( calculate(x,y) );
				g.fillRect(x,y,1,1);
			}
			//System.out.println("");
		}
	}
	int getWidth(){return width;}
	int getHeight(){return height;}
	public Dimension getMinimumSize() {return new Dimension( getWidth(),getHeight() );}
	public Dimension getMaximumSize() {return getMinimumSize();}
	public Dimension getPreferredSize() {return getMinimumSize();}
	public Color calculate( int x, int y ) {
		double size=(x2-x1);
		int n=0;
		double zx=x1+size*x/getWidth(), zy=y2+(y1-y2)*y/getHeight(),
		cx=zx, cy=zy;//Apfelmnnchen
		while (n<maxiteration) {
			double sqrx=zx*zx,sqry=zy*zy;
			if(sqrx+sqry>4){
				return UColor.getColor( 1000+n*70, 255, 205 );
				//return UColor.getColor( 1000+n*100, 255, 255 );
			}
			n++;
			zy=2*zx*zy+cy;
			zx=sqrx-sqry+cx;
		}
		return Color.black;
	}
}
