import java.applet.Applet;
import java.awt.*;
import java.awt.image.ColorModel;
import java.awt.image.MemoryImageSource;

public class Start3 extends Applet implements Runnable {
	ThreadGroup appletThreadGroup;
	Thread kicker;
	ColorCanvas canvas;
	
	public void init() {
		setLayout(new BorderLayout());
		add("Center", canvas = new ColorCanvas());
		appletThreadGroup = Thread.currentThread().getThreadGroup();
	}
	
	public synchronized void start() {
		if (canvas.getImage() == null) {
			kicker = new Thread(appletThreadGroup, this);
			kicker.start();
		}
	}
	
	public synchronized void stop() {
		try {
			if (kicker != null) {
				kicker.stop();
			}
		} catch (Exception e) {
		}
		kicker = null;
	}
	
	public void restart() {
		stop();
		canvas.setImage(null);
		start();
	}
	
/*	public static void main(String args[]) {
		Frame f = new Frame("Colormodel");
		Start3	ditherTest = new Start3();
		ditherTest.init();
		f.add("Center", ditherTest);
		f.pack();
		f.show();
		ditherTest.start();
	}*/
	
	public void run() {
		Thread me = Thread.currentThread();
		me.setPriority(3);
		Dimension csize=canvas.size();
		int height=csize.height;
		int width=csize.width;
		int pixels[] = new int[width * height];
		int index = 0;
		int xs=width/2, ys=height/2;
		for (int y = 0; y < height; y++) {
			int yd=y-ys, ydq=yd*yd;
			for (int x = 0; x < width; x++) {
				int xd=x-xs;
				double dist=Math.sqrt(xd*xd+ydq)/xs;
				if( dist>1 ) pixels[index++]=Color.gray.getRGB();
				//else pixels[index++] =(255 << 24) | ((x<=255)?UColor.getColorInt( y*3,255,x ):UColor.getColorInt( y*3,511-x,255 ));
				else {
					double alpha=Math.atan2( xd, yd );
					if( dist>0.5 ) pixels[index++] =(255 << 24) |  UColor.getColorInt( (int)(alpha*3*255/Math.PI), (int)(2*(1-dist)*255), 255 );
					else pixels[index++] =(255 << 24) | UColor.getColorInt( (int)(alpha*3*255/Math.PI), 255, (int)(2*dist*255) );
				}
				if (kicker != me) return;
			}
		}
		canvas.setImage(createImage(new MemoryImageSource( width, height,
		ColorModel.getRGBdefault(),pixels, 0, width)));
		kicker = null;
	}
}
