import java.awt.*;
public class UColor extends Object {
	private UColor(){}
	public static int getColorInt( int hue, int dark, int bright ) {
		final int ff=255, maxhue=6*ff;
		int h1, h2, rgb[]=new int[3];
		hue=(hue%maxhue+maxhue)%maxhue;
		h1=hue/ff;
		h2=hue%ff;
		switch (h1) {
		case 0:rgb[0]=ff;rgb[1]=h2;break;
		case 1:rgb[0]=ff-h2;rgb[1]=ff;break;
		case 2:rgb[1]=ff;rgb[2]=h2;break;
		case 3:rgb[1]=ff-h2;rgb[2]=ff;break;
		case 4:rgb[0]=h2;rgb[2]=ff;break;
		case 5:rgb[0]=ff;rgb[2]=ff-h2;
		}
		for( int i=0; i<3; i++ ) {
			rgb[i]=255+((rgb[i]-255)*bright)/255;
			rgb[i]=(rgb[i]*dark)/255;
		}
		return (rgb[0]<<16) + (rgb[1]<<8) + (rgb[2]);
	}
	public static Color getColor( int hue, int dark, int bright ) {
		return new Color( getColorInt( hue, dark, bright ) );
	}
	public static Color intermediate( Color from, Color to, double current ) {
		int rgb[]=new int[3];
		rgb [0]=from.getRed()+(int)((to.getRed()- from.getRed())*current);
		rgb [1]=from.getGreen()+(int)((to.getGreen()- from.getGreen())*current);
		rgb [2]=from.getBlue()+(int)((to.getBlue()- from.getBlue())*current);
		return new Color ((rgb[0]<<16) + (rgb[1]<<8) + (rgb[2]));
	}	
}
